\ 24C164.f


\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 



\ Routines for communicating with a 24LC164 serial eeprom

\ Uses acknowledge polling to check that the eeprom is not stalled in a
\ write cycle.

fload I2C.F
        
: ChkAck   ( ack -- )
        if    \ No ack?
                  \ Error Handling code here.
           page
           P." No ack on address"
           I2C_ERROR
        then
;

: SendRomAddr ( addr_byte control_byte --)
        begin     \ Loop sending start bits & control bytes until we get an ack.
           dup  
           BSTART    \ Generate start bit.
           TXBYTE
        0= until
        drop  \ Control byte.
        8lshift   \ Ready the byte address.
        TXBYTE    \ Send the byte address.
        ChkAck
        ;

code >RomAddr
        ; ( linear_addr -- address_byte control_byte)
        ; make an I2C bus address
        ; Control Byte:
        ; the 3 least significant bits of THIGH are the 3 msbs
        ; rom address. They must be shifted left so that the
        ; lsb is freed for the read/write bit. The 4 msbs are
        ; the unit address (typically 1010) 

        movpf THIGH, XHIGH      ; copy the high byte of the address
        clrf THIGH, F           ; clear the high byte of the address
        call _pushtop           ; make space on the stack
        
        rlncf XHIGH, W          ; shift the address left
        andlw 0x0E              ; mask off bits 0,4,5,6,7
        iorlw 0xA0              ; bitmap 1010XXX0
        movwf THIGH             ; save the control byte in THIGH
        return
endcode








