.(
        24C65.f
        Serial EEPROM routines.
)
 

\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 



\ Uses acknowledge polling to check that the eeprom is not stalled in a
\ write cycle.

fload I2C.F


:zzz  ChkAck   ( ack -- )
        if    \ No ack?
                  \ Error Handling code here.
           CR
           P." No ack on address"
           I2C_ERROR
        then
;

: SendRomAddr ( address_word control_byte --)
        
\ Loop sending start bits & control bytes until we get an ack.
        begin     
           dup
           BSTART    \ Generate start bit.
           TXBYTE
        0= until  \ Until ack = 0.
        
        drop      \ drop the control byte.
        
        dup
        TXBYTE    \ Send the high address byte.
        ChkAck 
        8lshift
        TXBYTE    \ Send the low address byte.
        ChkAck
        ;

code >RomAddr
        ; ( linear_addr -- address_word control_byte)
        ; make an I2C bus address
        ; the 3 most significant bits of linear_addr go into
        ; bits 1-3 of the control byte.
        movpf THIGH, XHIGH      ; copy the high byte of the address
        movlw 0x1F              ; mask the 3 ms bits
        andwf THIGH, F          ;    //
        call _pushtop           ; make space on the stack
        
        rrncf XHIGH, W          ; shift the address right 4 times
        rrncf WREG, F           ;   //
        rrncf WREG, F           ;   //
        rrncf WREG, F           ;   //
        andlw 0x0E              ; mask off bits 0,4,5,6,7
        iorlw 0xA0              ; bitmap 1010XXX0
        movwf THIGH             ; save the control byte in THIGH
        clrf TLOW, F
        return
endcode








