\ disp.f
\ Standard words to display strings and numbers.
\ This code depends on emit being previously defined.



\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 




code byteswap
; swap the high and low bytes of a word
        movfp THIGH, WREG
        movfp TLOW, THIGH
        movwf TLOW
        return
endcode

: type  ( c-addr u --) \ If u >0,  display the character string
                       \ at c-addr in program memory.

        dup 0= if
           drop drop exit  \ Bail if count is zero.
        then

        0 do               \ Loop outputting the u characters.

           dup P@            \ Fetch the program memory word.
           I even if
              byteswap emit
           else
              emit
              1+   \ Increment the address.
           then
        loop
        drop       \ Drop the pmem address.
         ;
         
code str_type 
; Called by code emitted by the compiler to type a literal string.
; c-addr is on the stack, and the string length is in wreg.
        call _pushtop
        movwf TLOW
        clrf THIGH, F
        goto _type
endcode



: .   ( n -- ) \ Display the number n on the display.

   dup 0< if negate [char] - emit then   \ Output a minus sign.
   0 >R         \ Count the number of digits.
   begin
      R> 1+ >R   \ Increment count.
      s>d 10 um/mod   ( n -- r q)
      dup 0=
   until
   ( -- r 0)     \ There are count number of r's.
   R> swap       \ Get the count.
   do
      48 + emit
   loop
   ;

: space BL emit ;

: spaces  ( n --)
   ?dup if
      0 do
        space
      loop
   then ;

