\ displayl.f
\ Code to utilize the lcd display


\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 


fload dispvars.f
fload blcd8.f

: scroll_mode  
     SCRN_SCROLL SCRN_mode C! ;
     
: overwrite_mode 
     SCRN_OVERWRITE SCRN_mode C! ;


: SCRNmode!  
    SCRN_SCROLL = if scroll_mode else overwrite_mode then ;

: XPOS! (XPOS) C! ;
: YPOS! (YPOS) C! ;

: at-xy 
        2dup YPOS! XPOS!
        LCD_at-xy ;

: incYPOS
        YPOS@ 1+ 
        dup LAST_LINE u> if
           drop
           SCRNmode@ SCRN_SCROLL = if LAST_LINE else 0 then
        then   
        YPOS! ;
: CR 
        LCD_CR
        0 XPOS!
        incYPOS ;
        
: (update_pos)
        XPOS@ 1+
        dup LAST_COLUMN u> if drop 0 LCD_CR incYPOS then
        XPOS! ;
   
: raw_emit ( ch -- )
        LCD! ;
        
: emit  ( x1 --)
        raw_emit (update_pos)
        ;


: page  LCD_page
        0 XPOS! 0 YPOS! ;
        
: home 0 0 at-xy ;

: end  LAST_COLUMN LAST_LINE at-xy ;

: clreol \ Clear to the end of the line.
        XPOS@ dup DISPLAY_WIDTH 1- u> if
           drop exit
        else
            dup >R
            YPOS@
            SCRNmode@
            overwrite_mode
            DISPLAY_WIDTH R> do
               bl raw_emit \ Spaces.
            loop
            SCRNmode!
        then
        at-xy ;                \ Restore XY position.
        
: clreop  \ Clear to the end of the page.
        clreol
        XYPOS@ \ Save current XY position.
        dup LAST_LINE = if drop drop exit then
        dup 1+ DISPLAY_HEIGHT swap do 0 I at-xy clreol loop
        at-xy ;

: show_cursor LCD_show_cursor ;

: hide_cursor LCD_hide_cursor ;

: BS  \ Backspace.
        XPOS@ dup 0= if drop exit then
        1- YPOS@ at-xy ;
        
