\ misc.f


\ This code is Copyright 1998, Peter Csapo. It is has been distributed free
\ of charge, and no claim is made to its accuracy, reliability or performance
\ in any way. 


\ Miscellaneous words. Timing words assume a 16 MHz pic clock input.


: >flag 0= 0= ;


\ Often used constants. Once declared, using the literal actually
\ invokes the constant.
0 constant zero
1 constant one
2 constant two
3 constant three
4 constant four
5 constant five
6 constant six
7 constant seven
8 constant eight
9 constant nine

16 constant sixteen
32 constant thirty_two
64 constant sixty_four
128 constant hundred_twenty_eight

255 constant MAX_BYTE

10 constant ten
100 constant hundred
1000 constant thousand


simulation [if]

: 100usecs drop ;

[else]

\ Accurate timing.

\ Delay, in 100 microsecond increments. Max of 255 increments.
code 100usecs
        ; ( n -- )
        ; increment is in TLOW
        incf TLOW, F            ; dummy
        dcfsnz TLOW, F          ; test for 0
        goto _poptop            ; return if 0

        ; Each loop is a delay of 400 instructions * 250 ns = 100 microsecs
        movlw 0x63              ; 99 decimal
        
        ; start inner loop, each iteration takes 4 instruction cycles
        nop
        decfsz WREG, F
        goto $-2
        ; end of inner loop

        decfsz TLOW, F 
        goto _100usecs        
        goto  _poptop
        ; deferred return
endcode 

: MS ( n -- )   \ Delay for n milliseconds.
        ?dup if
           0 do ten 100usecs loop    
        then ;
                
           
[then]        
   
:zzz restart 
     [ simulation ] [if]
         abort-simulation
     [then]

     begin again ;   \ Should be reset by the watchdog timer.
   
:zzz lockup
    [ simulation ] [if]
         abort-simulation
     [then]

   begin clrwdt again ; \ Not reset by watchdog timer.
   
 
: 1s clrwdt thousand MS clrwdt ;
   
: seconds  ( n -- )
        ?dup if 
           0 do 1s loop
        then ;
   
