        processor 17C44

       NOLIST



; This code is Copyright 1998, Peter Csapo. It is has been distributed free
; of charge, and no claim is made to its accuracy, reliability or performance
; in any way. 


; PICFORTH.INC
; V. 0.9.0


; Changes
;   v0.10.5
;       --  Optimized the rcall feature. Now emits return addresses in a table at the 
;           end of code.
;   v0.9.0
;       -- Changed to big endian.
;   v0.8.1
;        -- Added __rcall_return to return from the alternate calling mechanism
;           that does not use the hardware return stack.

;   v0.7 -- Changed start of code to 28h so each interrupt has 8 instructions.
    
;   v0.6 -- Temp registers tempA to tempD now moved to the low memory in
;           the stacks bank. (below the return stack). The unbanked memory
;           freed up will be used for:
;           a) BSR save during interrupt
;           b) ALUSTA save during interrupt
;           c) ???  -- reserve this for future use.
;           d) GLINTD lock count
;           This will mean that we won't have to disable interrupts when
;           switching between general purpose memory banks.
;  v0.5
;       -- Interrupt disabling/enabling done more intelligently using a
;          lock count.

;==========================================================================
;
;       Register Definitions
;
;==========================================================================

W                               EQU     H'0000'
F                               EQU     H'0001'

BANK0                           EQU     H'0000'
BANKSTACKS                      EQU     H'0000'
BANK1                           EQU     H'0001'
BANK2                           EQU     H'0002'
BANK3                           EQU     H'0003'

;----- Register Files -----------------------------------------------------

; INDF0 is now the top of the return stack RSTACK
RSTACK                          EQU     H'0000'
; we still must address indirectly to fetch and store, keep old name
INDF                            EQU     H'0000'
; FSR0 now is the return stack pointer RSP
RSP                             EQU     H'0001'
; we still need to address indirectly, so keep the old name
FSR                             EQU     H'0001'
PCL                             EQU     H'0002'
PCLATH                          EQU     H'0003'
ALUSTA                          EQU     H'0004'
T0STA                           EQU     H'0005'
CPUSTA                          EQU     H'0006'
INTSTA                          EQU     H'0007'
; INDF1 is always the next element on the stack, so call it STACK
STACK                           EQU     H'0008'
; FSR1 will be the stack ptr, so call it SP
SP                              EQU     H'0009'
WREG                            EQU     H'000A'
TMR0L                           EQU     H'000B'
TMR0H                           EQU     H'000C'
TBLPTRL                         EQU     H'000D'
TBLPTRH                         EQU     H'000E'
BSR                             EQU     H'000F'
PORTA                           EQU     H'0010'
DDRB                            EQU     H'0011'
PORTB                           EQU     H'0012'
RCSTA                           EQU     H'0013'
RCREG                           EQU     H'0014'
TXSTA                           EQU     H'0015'
TXREG                           EQU     H'0016'
SPBRG                           EQU     H'0017'
PRODL                           EQU     H'0018'
PRODH                           EQU     H'0019'

DDRC                            EQU     H'0110'
PORTC                           EQU     H'0111'
DDRD                            EQU     H'0112'
PORTD                           EQU     H'0113'
DDRE                            EQU     H'0114'
PORTE                           EQU     H'0115'
PIR                             EQU     H'0116'
PIE                             EQU     H'0117'

TMR1                            EQU     H'0210'
TMR2                            EQU     H'0211'
TMR3L                           EQU     H'0212'
TMR3H                           EQU     H'0213'
PR1                             EQU     H'0214'
PR2                             EQU     H'0215'
PR3L                            EQU     H'0216'
PR3H                            EQU     H'0217'

CA1L                            EQU     H'0216'
CA1H                            EQU     H'0217'

PW1DCL                          EQU     H'0310'
PW2DCL                          EQU     H'0311'
PW1DCH                          EQU     H'0312'
PW2DCH                          EQU     H'0313'
CA2L                            EQU     H'0314'
CA2H                            EQU     H'0315'
TCON1                           EQU     H'0316'
TCON2                           EQU     H'0317'

;----- ALUSTA Bits --------------------------------------------------------

FS3                             EQU     H'0007'
FS2                             EQU     H'0006'
FS1                             EQU     H'0005'
FS0                             EQU     H'0004'
OV                              EQU     H'0003'
Z                               EQU     H'0002'
DC                              EQU     H'0001'
C                               EQU     H'0000'

;----- CPUSTA Bits --------------------------------------------------------

STKAV                           EQU     H'0005'
GLINTD                          EQU     H'0004'
NOT_TO                          EQU     H'0003'
NOT_PD                          EQU     H'0002'

;----- INTSTA Bits --------------------------------------------------------

PEIF                            EQU     H'0007'
T0CKIF                          EQU     H'0006'
T0IF                            EQU     H'0005'
INTF                            EQU     H'0004'
PEIE                            EQU     H'0003'
T0CKIE                          EQU     H'0002'
T0IE                            EQU     H'0001'
INTE                            EQU     H'0000'

;----- PIE Bits -----------------------------------------------------------

RBIE                            EQU     H'0007'
TMR3IE                          EQU     H'0006'
TMR2IE                          EQU     H'0005'
TMR1IE                          EQU     H'0004'
CA2IE                           EQU     H'0003'
CA1IE                           EQU     H'0002'
TXIE                            EQU     H'0001'
RCIE                            EQU     H'0000'

;----- PIR Bits -----------------------------------------------------------

RBIF                            EQU     H'0007'
TMR3IF                          EQU     H'0006'
TMR2IF                          EQU     H'0005'
TMR1IF                          EQU     H'0004'
CA2IF                           EQU     H'0003'
CA1IF                           EQU     H'0002'
TXIF                            EQU     H'0001'
RCIF                            EQU     H'0000'

;----- PORTA Bits ---------------------------------------------------------

NOT_RBPU                        EQU     H'0007'
T0CKI                           EQU     H'0001'
INT                             EQU     H'0000'

;----- RCSTA Bits ---------------------------------------------------------

SPEN                            EQU     H'0007'
RX9                             EQU     H'0006'
RC9                             EQU     H'0006'    ; Backward compatibility only
NOT_RC8                         EQU     H'0006'    ; Backward compatibility only
RC8_9                           EQU     H'0006'    ; Backward compatibility only
SREN                            EQU     H'0005'
CREN                            EQU     H'0004'
FERR                            EQU     H'0002'
OERR                            EQU     H'0001'
RX9D                            EQU     H'0000'
RCD8                            EQU     H'0000'    ; Backward compatibility only

;----- T0STA Bits --------------------------------------------------------

INTEDG                          EQU     H'0007'
T0SE                            EQU     H'0006'
T0CS                            EQU     H'0005'
T0PS3                           EQU     H'0004'
PS3                             EQU     H'0004'
T0PS2                           EQU     H'0003'
PS2                             EQU     H'0003'
T0PS1                           EQU     H'0002'
PS1                             EQU     H'0002'
T0PS0                           EQU     H'0001'
PS0                             EQU     H'0001'

;----- TCON1 Bits ---------------------------------------------------------

CA2ED1                          EQU     H'0007'
CA2ED0                          EQU     H'0006'
CA1ED1                          EQU     H'0005'
CA1ED0                          EQU     H'0004'
T16                             EQU     H'0003'
TMR3CS                          EQU     H'0002'
TMR2CS                          EQU     H'0001'
TMR1CS                          EQU     H'0000'

;----- TCON2 Bits ---------------------------------------------------------

CA2OVF                          EQU     H'0007'
CA1OVF                          EQU     H'0006'
PWM2ON                          EQU     H'0005'
PWM1ON                          EQU     H'0004'
CA1                             EQU     H'0003'
NOT_PR3                         EQU     H'0003'
CA1_PR3                         EQU     H'0003'
TMR3ON                          EQU     H'0002'
TMR2ON                          EQU     H'0001'
TMR1ON                          EQU     H'0000'

;----- TXSTA Bits ---------------------------------------------------------

CSRC                            EQU     H'0007'
TX9                             EQU     H'0006'
NOT_TX8                         EQU     H'0006'    ; Backward compatibility only
TX8_9                           EQU     H'0006'    ; Backward compatibility only
TXEN                            EQU     H'0005'
SYNC                            EQU     H'0004'
TRMT                            EQU     H'0001'
TX9D                            EQU     H'0000'
TXD8                            EQU     H'0000'    ; Backward compatibility only

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM        H'3FF'
        __BADRAM        H'118'-H'11F', H'218'-H'2FF', H'318'-H'3FF'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_PMC_MODE                       EQU     H'00AF'
_XMC_MODE                       EQU     H'FFBF'
_MC_MODE                        EQU     H'FFEF'
_MP_MODE                        EQU     H'FFFF'
_WDT_NORM                       EQU     H'FFF3'
_WDT_OFF                        EQU     H'FFF3'
_WDT_64                         EQU     H'FFF7'
_WDT_256                        EQU     H'FFFB'
_WDT_1                          EQU     H'FFFF'
_LF_OSC                         EQU     H'FFFC'
_RC_OSC                         EQU     H'FFFD'
_XT_OSC                         EQU     H'FFFE'
_EC_OSC                         EQU     H'FFFF'

        LIST


;******************************************************************************
;******************************************************************************
        ; noexpand


; Instruction aliases.
#define         gprbank         movlr
#define         periphbank      movlb

; Special purpose unbanked memory locations
GLINT_LOCK     equ             0x1A    ; Lock count for disabling interrupts.
BSR_SAVE       equ             0x1B    ;
ALUSTA_SAVE    equ             0x1C    ;
RESERVED1      equ             0x1D    ; Reserved for application use.
THIGH          equ             0x1E    ;
TLOW           equ             0x1F    ;

; Special memory locations
XLOW           equ             0xFE
XHIGH          equ             0xFF    ;

; Temporary registers in the stack bank
tempA          equ             0x20    ;
tempB          equ             0x21    ;
tempC          equ             0x22    ;
tempD          equ             0x23    ;

; Special registers in the stack bank.
Rom_Low         equ             0x24    ; The current rom address.
Rom_High        equ             0x25    ;     //

; THE COMPILER STARTS ALLOCATING VARIABLES AT ADDRESS 0x26 !!

; THE START OF THE STACK SPACE IS SET BY COMPILER OPTIONS !!

; Bottom of the data stack, not set quite at the bottom of mem
; to give breathing room for an underflow.
STACKORG   equ   0xF0 

; Pseudo instructions.
;******************************************************************************
; move a literal value through w into any file register
; without corrupting the stack
literal macro lit_val, file_reg
        decf SP, F
        movwf STACK                ; save wreg
        movlw   lit_val            ; load w with literal value
        movwf   file_reg           ; copy literal into destination
        movfp STACK, WREG
        incf SP, F
        endm
;******************************************************************************
; push words onto the stack
push    macro  lit_word         ; push a literal word onto the stack
        decf SP, F
        movpf TLOW, STACK      ; grow stack
        decf SP, F
        movpf THIGH, STACK
        movlw  high lit_word    ; get high byte
        movwf THIGH
        movlw low lit_word      ; get low byte
        movwf TLOW
        endm

pushf   macro file_reg          ; push a file register onto the stack
        decf SP, F
        movpf TLOW, STACK      ; grow stack
        decf SP, F
        movpf THIGH, STACK
        clrf THIGH, F           ; clear high byte
        movfp file_reg, TLOW    ; copy reg into low byte
        endm
;******************************************************************************
; duplicate the top stack cell
dup     macro
        decf SP, F              ; grow the stack
        movfp TLOW, STACK       ; push top on the stack
        decf SP, F
        movfp THIGH, STACK
        endm
;******************************************************************************
; drop the top of the stack
drop    macro
        movfp STACK, THIGH
        incf SP, F
        movfp STACK, TLOW
        incf SP, F
        endm
;******************************************************************************        
; pop the top of the stack into the destination register
popf    macro  dest_reg
        movpf TLOW, dest_reg
        movpf STACK, THIGH       ; new top
        incf SP, F               ; shrink the stack
        movpf STACK, TLOW
        incf SP, F
        endm
;******************************************************************************
; drop a value from the return stack
Rdrop   macro
        decf RSP, F             ; shrink the return stack
        decf RSP, F
        endm
;******************************************************************************




; Leave space for interrupt vectors.
        org 0x28



__start   ; label the code origin here


        org 0x00

; We have 8 instructions before we collide with the first interrupt vector.
        ; setup the stacks

     
        movlw STACKORG          ;
        movwf SP                ;
        movlw RSTACKORG
        movwf RSP               

        ; initialize the GLINT lock count to 1
        ; i.e. interrupts are initially disabled
        clrf GLINT_LOCK, F
        incf GLINT_LOCK, F
        gprbank BANKSTACKS      ; address stacks
        goto _main              ; let the adventure begin

        org __start


